Imports System.Data
Imports System.Data.oledb
Public Class frmClientes
    Dim cn As New OleDbConnection
    Dim daClientes As OleDbDataAdapter
    Dim ds As New DataSet
    Dim nombreBBDD = Application.StartupPath & "\Ejemplo.mdb"

    Dim WithEvents bs As New BindingSource

    'Posicin actual se utiliza para volver a la fila donde se estaba
    'antes de cancelar una operacin
    Private PosicinActual As Long
    Private Sub frmClientes_Load(ByVal sender As System.Object, _
              ByVal e As System.EventArgs) Handles MyBase.Load
        ConfigurarAccesoADatos()
        EnlazarADatos()

        'Se mueve el BindingSource al final y al principio 
        'para actualizar el total de registros
        bs.MoveLast()
        bs.MoveFirst()
    End Sub
    Private Sub ConfigurarAccesoADatos()
        'Abre la conexin, establece el adaptador de datos y rellena el Dataset

        'Abrir la conexin
        cn.ConnectionString = "PROVIDER=Microsoft.jet.oledb.4.0;Data Source=" & nombreBBDD
        cn.Open()

        'Configurar los adaptadores de datos
        daClientes = New OleDbDataAdapter("SELECT * FROM Clientes", cn)

        'Cargar el dataset
        daClientes.Fill(ds, "Clientes")

        'Cerrar la conexin
        cn.Close()

        'Establecer la clave principal
        Dim claves(0) As DataColumn
        claves(0) = New DataColumn
        claves(0) = ds.Tables("Clientes").Columns("IdCliente")
        ds.Tables("Clientes").PrimaryKey = claves

        'Crear las rdenes de actualizacin
        Dim cbClientes As OleDbCommandBuilder = New OleDbCommandBuilder(daClientes)
    End Sub
    Private Sub EnlazarADatos()
        'El Dataset se ha rellenado con la tabla Clientes
        bs.DataSource = ds
        bs.DataMember = "Clientes"

        'Se enlazan los cuadros de texto con la propiedad Text
        txtIdCliente.DataBindings.Add(New Binding("Text", bs, "IdCliente", True))
        txtApellidos.DataBindings.Add(New Binding("Text", bs, "Apellidos", True))
        txtNombre.DataBindings.Add(New Binding("Text", bs, "Nombre", True))
        txtCiudad.DataBindings.Add(New Binding("Text", bs, "Ciudad", True))
        txtProvincia.DataBindings.Add(New Binding("Text", bs, "Provincia", True))
        txtCP.DataBindings.Add(New Binding("Text", bs, "CP", True))
    End Sub

    Private Sub bs_PositionChanged(ByVal sender As Object, _
                  ByVal e As System.EventArgs) Handles bs.PositionChanged
        'Actualizar la posicin del registro actual
        lblPosicin.Text = "Pedido " & bs.Position + 1 & " de " & bs.Count
    End Sub

    Private Sub btnSiguiente_Click(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles btnSiguiente.Click
        If bs.Position < bs.Count - 1 Then
            bs.MoveNext()
        Else
            MessageBox.Show("Se ha llegado al ltimo cliente", Me.Text, _
                             MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub btnPrimero_Click(ByVal sender As System.Object, _
               ByVal e As System.EventArgs) Handles btnPrimero.Click
        bs.MoveFirst()
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles btnAnterior.Click
        If bs.Position > 0 Then
            bs.MovePrevious()
        Else
            MessageBox.Show("Se ha llegado al primer cliente", Me.Text, _
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub btnltimo_Click(ByVal sender As System.Object, _
             ByVal e As System.EventArgs) Handles btnltimo.Click
        bs.MoveLast()
    End Sub

    Private Sub btnSalir_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles btnSalir.Click
        Me.Close()
    End Sub
    Private Sub btnActualizar_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles btnActualizar.Click
        'EndEdit pasa los cambios al Dataset
        'Puede generar un error si se ha aadido una fila
        'con la clave repetida
        Try
            bs.EndEdit()
        Catch ex As ConstraintException
            MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, _
                                        MessageBoxIcon.Information)
            'ds.Tables("Clientes").RejectChanges()
        End Try
        'Si se han producido cambios en el Dataset, 
        'la coleccin GetChanges est vaca y
        'se actualiza el conjunto de datos
        If Not ds.GetChanges() Is Nothing Then
            Try
                daClientes.Update(ds, "Clientes")
                'Con AcceptChanges se actualiza el estado de 
                'modificado, aadido o borrado de las filas del Dataset
                ds.AcceptChanges()
            Catch ex As Exception
                MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, _
                        MessageBoxIcon.Information)
                ds.Tables("Clientes").RejectChanges()
            End Try
        End If
    End Sub

    Private Sub btnBorrar_Click(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles btnBorrar.Click
        'Si existe una fila actual, la borra
        If Not bs.Current Is Nothing Then
            If MessageBox.Show("Desea borrar el cliente actual?", Me.Text, _
                             MessageBoxButtons.YesNo, MessageBoxIcon.Question, _
                             MessageBoxDefaultButton.Button2) = _
                             Windows.Forms.DialogResult.Yes Then
                bs.RemoveCurrent()
            End If
        End If
    End Sub

    Private Sub btnNuevo_Click(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles btnNuevo.Click
        'Desactivar botones
        'Los botones Borrar, Salir, Nuevo y Actualizar no estn accesibles
        'cuando se est rellenando un nuevo Cliente
        btnBorrar.Enabled = False
        btnSalir.Enabled = False
        btnNuevo.Enabled = False
        btnActualizar.Enabled = False
        'Tampoco ser posible navegar por el BindingSource
        PanelNavegacin.Enabled = False

        'Los botones Aceptar y Cancelar que no estaban visibles al cargar
        'el formulario, se vuelven visibles.
        'Como estn situados por encima de Nuevo y Actualizar ahora 
        'Nuevo y Actualizar no son visibles
        btnCancelar.Visible = True
        btnAceptar.Visible = True

        'Se guarda la posicin actual por si se cancela la operacin
        PosicinActual = bs.Position

        'Se aade un nuevo cliente VACIO al final de la lista de BindingSource
        bs.AddNew()
    End Sub

    Private Sub btnCancelar_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles btnCancelar.Click
        'CancelEdit cancela la operacin de edicin en curso
        '(Cancela la insercin de un nuevo cliente)
        bs.CancelEdit()
        'Activar botones 
        'Este botn slo est accesible cuando se est creando un nuevo cliente
        'Los botones Borrar, Salir, Nuevo y Actualizar vuelven a estar accesibles
        btnBorrar.Enabled = True
        btnSalir.Enabled = True
        btnNuevo.Enabled = True
        btnActualizar.Enabled = True
        'El panel de navegacin tambin vuelve a estar accesible
        PanelNavegacin.Enabled = True

        'Los botones Aceptar y Cancelar se vuelven invisibles, dejando
        'ver los botones Nuevo y Actualizar que estn debajo
        btnCancelar.Visible = False
        btnAceptar.Visible = False

        'Se restaura la posicin anterior en la lista
        bs.Position = PosicinActual
    End Sub

    'Acepta la insercin de un nuevo cliente
    'Se supone que los datos del cliente ya se han introducido
    'en los cuadros de texto, por lo que tambin estn ya en el BindingSource
    'y en el DataSet
    'Slo est disponible cuando se est dando de alta un cliente
    Private Sub btnAceptar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles btnAceptar.Click
        'Activar botones 
        'Este botn slo est accesible cuando se est creando un nuevo cliente
        'Los botones Borrar, Salir, Nuevo y Actualizar vuelven a estar accesibles
        btnBorrar.Enabled = True
        btnSalir.Enabled = True
        btnNuevo.Enabled = True
        btnActualizar.Enabled = True
        'El panel de navegacin tambin vuelve a estar accesible
        PanelNavegacin.Enabled = True

        'Los botones Aceptar y Cancelar se vuelven invisibles, dejando
        'ver los botones Nuevo y Actualizar que estn debajo
        btnCancelar.Visible = False
        btnAceptar.Visible = False
    End Sub

    'Se ejecuta al cerrar el formulario
    Private Sub frmGestinClientes_FormClosing(ByVal sender As Object, _
                      ByVal e As System.Windows.Forms.FormClosingEventArgs) _
                      Handles Me.FormClosing
        'Si hay cambios pendientes al cerrar el formulario
        'EndEdit pasa los cambios al Dataset
        'Puede generar un error si se ha aadido una fila
        'con la clave repetida
        Try
            bs.EndEdit()
        Catch ex As ConstraintException
            MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, _
                                        MessageBoxIcon.Information)
            e.Cancel = True
            Exit Sub
        End Try

        If Not ds.GetChanges Is Nothing Then
            'Pregunta si se quieren guardar
            If MessageBox.Show("Guardar las modificaciones pendientes?", Me.Text, _
                            MessageBoxButtons.YesNo, MessageBoxIcon.Information, _
                            MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
                'Si se contesta si se llama al controlador del evento btnActualizar.Click
                btnActualizar.PerformClick()
            End If
        End If
    End Sub
End Class
